/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/config/conf_scan.lex,v 1.2 2002/04/02 02:07:05 koni Exp $ 
  $Author: koni $ $Date: 2002/04/02 02:07:05 $ $Name: slan-release-0-04 $
  $Revision: 1.2 $

*/
   
%{
#include "conf_parse.h"
%}
%option yylineno

%%
#.*\n
\{			 { return OPEN_BRACE; }
\}			 { return CLOSE_BRACE; }
yes {return YES; }
no {return NO; }
control-port {return CONTROL_PORT; }
transport-port {return TRANSPORT_PORT; }
service-identifier {return SERVICE_IDENTIFIER; }
node-identifier {return NODE_IDENTIFIER; }
rsa-label {return RSA_LABEL; }
rsa-modulus {return RSA_MODULUS; }
rsa-public {return RSA_PUBLIC; }
rsa-private {return RSA_PRIVATE; }
dh-prime {return DH_PRIME; }
dh-generator {return DH_GENERATOR; }
assign-ips {return ASSIGN_IPS; }
ip-masquerade {return IPMASQ; }
slan-ipaddress {return SLAN_IPADDRESS; }
router {return ROUTER; }
broadcast {return BROADCAST; }
netmask {return NETMASK; }
nameserver {return NAMESERVER; }
rsakey	   { return RSAKEY; }
Diffee-Hellman-group   { return DH; }
server-address	       { return SERVER_ADDRESS; }

[0-9]+ { return INTEGER; }
[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3} { return IPADDR; }
0x[A-Fa-f0-9]+|[A-Fa-f0-9]+    { return HEXSTRING; }
\".+\"			       { return STRING; };
\"[A-Za-z0-9_\-]+(\.[A-Za-z0-9_\-])*\"	 { return HOSTNAME; }
[ \t\n]+		
;		{ return ENDL; }
.		{ return FLEX_ERROR; }
%%

int yywrap() {
    return 1;
}

char *get_yytext() {
     return yytext;
}
