/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/control/version.c,v 1.1.1.1 1999/12/09 01:16:35 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:35 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef WIN32
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#else
#include "slan_windows.h"
#endif

#include "slan_types.h"

#include "control_tcp.h"
#include "slan_version.h"


static void send_version(int fd) {
  unsigned char version_message[8];
  u_int32_t major_version;
  u_int32_t minor_version;
  
  major_version = htonl(SLAN_MAJOR_VERSION);
  minor_version = htonl(SLAN_MINOR_VERSION);
  memcpy(version_message, &major_version, 4);
  memcpy(version_message + 4, &minor_version, 4);

  send(fd, version_message, 8, 0);
}

int check_version(int fd) {
  u_int32_t minor_version, major_version;
  unsigned char version_message[8];

  send_version(fd);

  if (recv(fd, version_message, 8, 0)!=8) return -1;

  memcpy(&major_version, version_message, 4);
  memcpy(&minor_version, version_message + 4, 4);
  
  major_version = ntohl(major_version);
  minor_version = ntohl(minor_version);
  
  if (major_version != SLAN_MAJOR_VERSION) return -1;
  return (SLAN_MINOR_VERSION - minor_version);
}

