/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/control_tcp.h,v 1.1.1.1 1999/12/09 01:16:35 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:35 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef CONTROL_TCP_H
#define CONTROL_TCP_H
#ifndef WIN32
#include <sys/types.h>
#include <sys/socket.h>
#endif

#include <netinet/in.h>
#include "slan_types.h"
#include "slan_session.h"


enum { DIFFIE_HELLMAN = 0, RSAAUTH, SLAN_IPADDR, SLAN_VERSION, CLIENTAUTH, 
       IPCONF, MACCONF, KEYCHANGE, KEEPALIVE, SHUTDOWN, MAX_TYPES };

enum { KEEPALIVE_PING = 0, KEEPALIVE_RESPONSE };

enum { KEYCHANGE_REQUEST = 0, KEYCHANGE_READY };


tcp_socket_t *client_open_socket(unsigned char *server_name, unsigned int *, int);
SOCKET server_open_socket();
int control_msg_send(control_msg_t *msg, slan_session_t *session_obj, 
		     int *timeout);
int control_msg_recv(control_msg_t **r_msg, slan_session_t *session_obj, 
		     int *timeout);

control_msg_t *new_control_msg(uint32 protocol, uint32 type, 
			       slan_session_t *session_obj);
void control_msg_destruct(control_msg_t *msg);
void msg_append_tlv(control_msg_t *msg, uint32 type, uint32 length, uchar *value);
void msg_search_tlv(control_msg_t *msg, uint32 type, uint32 *length, uchar **value);

#endif

