/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/rsaauth.h,v 1.1.1.1 1999/12/09 01:16:36 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:36 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef RSAAUTH_H
#define RSAAUTH_H
#ifdef HAVE_GMP_H
#include <gmp.h>
#else
#include "slan_gmp3.h"
#endif
#include "slan_session.h"

typedef struct {
  mpz_t modulus_mpz;
  mpz_t private_mpz;
  mpz_t public_mpz;
  unsigned char *fingerprint;
  int fingerprint_length;
} rsa_keydata_t;

int rsaauth_initiate(slan_session_t *);
int rsaauth_listen(slan_session_t *);
#endif

