/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/slan_alloc.h,v 1.1.1.1 1999/12/09 01:16:36 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:36 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef _SLAN_ALLOC_H
#define _SLAN_ALLOC_H

#define MEMDEBUG

#ifndef WIN32
#define slan_memfree(x) free(x)
#define slan_malloc(x)  malloc(x)
#define slan_calloc(x,y)  calloc(x,y)
#define slan_realloc(x,y) realloc(x,y)
#else

extern void memory_cleanup();

#ifdef MEMDEBUG
#define slan_malloc(x) slan_mallocd(x, __FILE__, __LINE__)
#define slan_calloc(x, y) slan_callocd(x, y, __FILE__, __LINE__)
#define slan_realloc(x, y) slan_reallocd(x, y, __FILE__, __LINE__)
#define slan_memfree(x) slan_memfreed(x, __FILE__, __LINE__)
extern void slan_memfreed(void *orig, char *file, int line);
extern void *slan_mallocd(int size, char *file, int line);
extern void *slan_callocd(int num, int size, char *file, int line);
extern void *slan_reallocd(void *orig, int size, char *file, int line);
#else
extern void slan_memfree(void *orig);
extern void *slan_malloc(int size);
extern void *slan_calloc(int num, int size);
extern void *slan_realloc(void *orig, int size);
#endif

#endif
#endif

