/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/slan_config.h,v 1.1.1.1 1999/12/09 01:16:36 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:36 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef _SLAN_CONFIG_H
#define _SLAN_CONFIG_H
#ifdef HAVE_GMP_H
#include <gmp.h>
#else
#include "slan_gmp3.h"
#endif

typedef struct {
  mpz_t modulus_mpz;
  mpz_t private_mpz;
  mpz_t public_mpz;
  char *fingerprint;
  char *label;

  char *modulus;
  char *private;
  char *public;
} rsakey_t;

typedef struct {
  char *gen;
  char *prime;
  mpz_t generator_mpz;
  mpz_t modulus_mpz;
} dh_t;

typedef struct {
  int server;

  char *service_identifier;
  char *node_identifier;
  int control_port;
  int transport_port;
  rsakey_t *rsakey;
  dh_t *dh;
  int assign_ips;
  int ipmasq;
  char *slan_ipaddress;
  char *router;
  char *broadcast;
  char *netmask;
  char *nameserver1;
  char *nameserver2;
  char *server_address;
} slan_conf_t;

int slan_client_load_configuration(char *);
int slan_server_load_configuration(char *);

/* Someday, this must be easier for a user/admin to specify, or SLAN should
   auto-detect the nobody user. */
#define SLANRUN_UID (99)
#define SLANRUN_GID (99)


#endif

