/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/slan_message.h,v 1.1.1.1 1999/12/09 01:16:37 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:37 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef SLAN_MESSAGE_H
#define SLAN_MESSAGE_H

/* This is the basic unit passed around and operated on by the members of a 
   protocol stack. Since nothing programmed (yet) is using the trailer, I 
   don't acutally handle it anywhere. */

typedef struct {
  unsigned char *buffer;
  unsigned char *header;
  unsigned char *data;
  unsigned char *trailer;
  int length;
  int maxspace;
} slan_message_t;

/* Macros for manipulating the slan_message structure */

#define slan_reserve(message, arg) (message)->header -= (arg)
#define slan_release(message, arg) (message)->header += (arg)
#define slan_pop(message, arg) { (message)->header += (arg); \
                               (message)->data += (arg);   \
                               (message)->length -= (arg); }
#define slan_set(message) { (message)->length += ((message)->data - (message)->header); ((message)->data = (message)->header); }

/* For the moment, slan_free() doesn't do anything. */
#define slan_free(message)						     
#endif

