/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/slan_types.h,v 1.1.1.1 1999/12/09 01:16:37 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:37 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
/* 
 * This file defines types which need to 
 * work on both platforms
 */
#ifndef SLAN_TYPES_H
#define SLAN_TYPES_H
#include "magicnum.h"

#ifdef WIN32

typedef UINT u_int32_t;
typedef UINT uint32;
typedef USHORT u_int16_t;
typedef UINT socklen_t;
typedef void *pthread_t;
typedef void *pthread_mutex_t;

# define INLINE_FUNC __inline

# define LEAVE_THREAD(x) slan_stop(x);

#else /* linux defines */

typedef int SOCKET;

# define INLINE_FUNC inline
# define LEAVE_THREAD(x) exit(x);



#endif

typedef unsigned char uchar;
typedef unsigned long uint32;

typedef struct {
  uchar buf[CONTROL_MSG_MAX_SIZE];
  int start;
  int end;
  int tmp;
  SOCKET fd;
} tcp_socket_t;
  
typedef struct tlv_struct {
  uint32 type;
  uint32 length;
  uchar *value;
  struct tlv_struct *next;
} tlv_t;
  
typedef struct {
  uint32 type;
  uint32 subtype;
  tlv_t *tlv_list;
} control_msg_t;


#endif /* SLAN_TYPES_H */

