/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/slan_windows.h,v 1.1.1.1 1999/12/09 01:16:37 koni Exp $
  $Author: koni $ $Date: 1999/12/09 01:16:37 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/

#ifndef WIN32
#error This shouldn't be included here -- something is suspicious
#endif

#ifndef SLAN_WINDOWS_H
#define SLAN_WINDOWS_H

#define WIN32_LEAN_AND_MEAN	/* yeah, as if this were possible. */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>

#include <windows.h>
#include <winsock2.h>		/* we require winsock2 for event-based select */

#define CHAR_BIT 8		/* 8 bits per char. I hope this is standard on all windows systems. ;) */
#define UCHAR_MAX 255		/* 0-255 with 8 bits, sure */

#define __LITTLE_ENDIAN 1234
#define __BYTE_ORDER __LITTLE_ENDIAN

int gettimeofday(struct timeval *, struct timeval *);
int recvall(SOCKET, UCHAR *, UINT, UINT);
unsigned int get_data(HWND, char *, char *, char *, int, BOOL);
HWND get_current_main_window();
void release_current_main_window();
void new_slan_status(int, char *, int);
HANDLE start_slan_thread(char *config_file, HANDLE dieevent);
int get_default_gateway(unsigned int *gateway_addr, int *if_idx);
void slan_stop(int);
void stop_all_gui();
BOOL mem_init();
void mem_destroy();

typedef struct {
	HANDLE slan_die_event;
	char *slan_server_config;
} slan_thread_start_t;

/* kludge to get this to work correctly under windows.. */
#define HAVE_GMP_H

#endif // SLAN_WINDOWS_H
