/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/include/stack_register.h,v 1.1.1.1 1999/12/09 01:16:37 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:37 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#ifndef STACK_REGISTER_H
#define STACK_REGISTER_H

#include "proto_stack.h"
#include "sym_cipher.h"

/* Prototypes for protocol stack registration functions */
int fragment_register(proto_stack_t *);
#ifdef WIN32
int winclient_udplink_register(proto_stack_t *, char *, int, slan_session_t *, SOCKET *);
int winslan_link_register(proto_stack_t *, void *opaque_driver);
#else
int slan_link_register(proto_stack_t *, int slan_socket, slan_session_t *);
int client_udplink_register(proto_stack_t *, char *, int, slan_session_t *);
#endif
int symmetric_cipher_register(proto_stack_t *, cipher_t *);
int terminate_register(proto_stack_t *);
struct sockaddr_in *server_udplink_register(proto_stack_t *, int udp_fd);
int sequence_register(proto_stack_t *stack_entry);
int session_id_register(proto_stack_t *stack_entry);
int message_sign_register(proto_stack_t *stack_entry, mac_t *mac);

#endif


