#!/bin/sh

# KONI May 31, 2001
# Quick dirty script to figure out whether kernel is 2.2 or 2.4
# to be replaced with some more general pre-build configuration script

echo
rm -f slan_device.c
VERSION=`uname -r | cut -d. -f 1,2`

if [ -z $VERSION ]; then
    echo "Could not determine kernel version with uname -r. Your build will"
    echo "be incomplete. The kernel driver cannot be built."
    exit 1;
fi

if [ "2.2" = $VERSION ]; then
    echo "Kernel version 2.2 detected."
    echo
    ln -s slan_device-2.2.c slan_device.c
    exit 0
fi

if [ "2.4" = $VERSION ]; then
    echo "Kernel version 2.4 detected."
    echo
    ln -s slan_device-2.4.c slan_device.c
    exit 0
fi

echo
echo "Sorry, kernel version `uname -r` is not currently supported"
echo "Your build will be incomplete."
echo

