/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/tests/test_blowfish.c,v 1.1.1.1 1999/12/09 01:16:42 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:42 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#include <stdio.h>
#include <stdlib.h>
#include "sym_cipher.h"

cipher_t *get_blowfish(void);
int blowfish_variable_key_test(cipher_t *);
int blowfish_fixed_key_test(cipher_t *);

int main(int argc, char *argv[]) {
  cipher_t *blowfish;

  blowfish = get_blowfish();

  fprintf(stderr,"Running a variable key test....\n");
  if (blowfish_variable_key_test(blowfish)) {
    fprintf(stderr,"Variable key test has failed.\n");
  } else {
    fprintf(stderr,"Variable key test passed.\n");
  }

  fprintf(stderr,"Running a fixed key test....\n");
  if (blowfish_fixed_key_test(blowfish)) {
    fprintf(stderr,"Fixed key test has failed.\n");
  } else {
    fprintf(stderr,"Fixed key test passed.\n");
  }

  blowfish->close(blowfish);
  return 0;
}


