/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage6/transport/fragment.c,v 1.1.1.1 1999/12/09 01:16:43 koni Exp $ 
  $Author: koni $ $Date: 1999/12/09 01:16:43 $ $Name: slan-release-0-04 $
  $Revision: 1.1.1.1 $

*/
   
#include <stdlib.h>
#include <proto_stack.h>
#include <slan_message.h>


static void fragment_down(proto_stack_t *stack, slan_message_t *message) {

  /* Fragmenting is currently not implemented */
  stack->next->down(stack->next, message);
}

static void fragment_up(proto_stack_t *stack, slan_message_t *message) {
  
  /* Fragmenting is currently not implemented */
  stack->prev->up(stack->prev, message);
}

int fragment_register(proto_stack_t *stack_entry) {

  stack_entry->up = fragment_up;
  stack_entry->down = fragment_down;
  stack_entry->header_reserve = 0;
  stack_entry->trailer_reserve = 0;
  stack_entry->data = NULL;
  return 0;
}

